IMPLEMENTATION MODULE  IntArrays;

  (*
    Implementation and Revisions:
    ============================
    
    Author  Date        Description of change
    ------  ----        ---------------------
    AF      08/05/2010  First implementation
    
  *)
  

  CONST 
    maxArrEles = 32768;
  TYPE 
    IntArray = POINTER TO IntsArray;
    IntsArray = RECORD
                    ints: ARRAY [0.. maxArrEles-1] OF INTEGER;
                    curNoOfArrEles: INTEGER;
                   END;
  VAR
    root: IntArray;

  PROCEDURE AllocateIntArray(VAR ia: IntArray; length: INTEGER);
  BEGIN (* AllocateIntArray *)
    (*
       If ia does not exist allocate ia and add it to the list.  Don't allow
       for adding if it should already exist!
     *)
  END AllocateIntArray;

  PROCEDURE IntArrayExists(ia: IntArray): BOOLEAN;
  BEGIN (* IntArrayExists *)
    (* check whether ia is not notAllocatedIntArray and else search in list 
     for presence. This is a bit costly but safe. *)
  END IntArrayExists;

  PROCEDURE DeallocateIntArray(VAR ia: IntArray);
  BEGIN (* DeallocateIntArray *)
    (* if ia exists deallocate it and remove it from list *)
  END DeallocateIntArray;

  PROCEDURE IntArrayLength(ia: IntArray): INTEGER;
  BEGIN (* IntArrayLength *)
    IF IntArrayExists(ia) THEN
      RETURN ia^.curNoOfArrEles
    ELSE
      RETURN undefInteger
    END(*IF*);
  END IntArrayLength;

  PROCEDURE SetIAEle(VAR ia: IntArray; i: CARDINAL; val: INTEGER);
    VAR ix,j : INTEGER; ianew : IntArray;
  BEGIN (* SetIAEle *)
    IF IntArrayExists(ia) AND (i <= maxArrEles) THEN
      ix := i - 1;
      IF ix <= ia^.curNoOfArrEles THEN
        ia^.ints[ix] := val;
      ELSE
        AllocateIntArray(ianew,i);
        IF ianew <> notAllocatedIntArray THEN
          FOR j:= 0 TO ia^.curNoOfArrEles DO
            ianew^.ints[j] := ia^.ints[j];
          END(*FOR*);
          ianew^.ints[ix] := val;
          DeallocateIntArray(ia);
          ia := ianew;
        END(*IF*);
      END(*IF*);
    END(*IF*);
  END SetIAEle;

  PROCEDURE IAEle(ia: IntArray; i: CARDINAL): INTEGER;
  BEGIN (* IAEle *)
    IF IntArrayExists(ia) THEN
      RETURN ia^.ints[i]
    ELSE
      RETURN undefInteger
    END(*IF*);
  END IAEle;


  (***********************************)
  (*#####   Module Management   #####*)
  (***********************************)

  PROCEDURE InitIntArrays;
  BEGIN (*InitIntArrays*)
    notAllocatedIntArray := IntArray(NIL);
    root := notAllocatedIntArray;
    (*
       inite garbage collection by installing a term procedure in RMTS for
       discarding entire list in case the program stops or is abnormally
       terminated 
     *)
  END InitIntArrays;
  
BEGIN (* IntArrays *)
  InitIntArrays;
END IntArrays.
